commit 5d8f88f3fb6fecc1002f30dbc92d011a06d0456a
Author: jklowden <jklowden>
Date:   Tue Jan 26 18:15:39 2010 +0000

    build with sspi on Win32, not really working yet

diff --git a/ChangeLog b/ChangeLog
index 82bb698..ba4612f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Tue Jan 26 13:11:37 EST 2010	JK Lowden <jklowden@freetds.org>
+	* Nmakefile src/tds/sspi.c win32/config.h
+	- build with sspi on Win32, not really working yet
+
 Tue Jan 26 11:25:49 EST 2010	JK Lowden <jklowden@freetds.org>
 	* Nmakefile generate header files for CVS checkout
 
@@ -2196,4 +2200,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2957 2010/01/26 16:28:04 jklowden Exp $
+$Id: ChangeLog,v 1.2958 2010/01/26 18:15:39 jklowden Exp $
diff --git a/Nmakefile b/Nmakefile
index 78369b3..bc360ed 100755
--- a/Nmakefile
+++ b/Nmakefile
@@ -1,4 +1,4 @@
-# $Id: Nmakefile,v 1.3 2010/01/26 16:28:05 jklowden Exp $
+# $Id: Nmakefile,v 1.4 2010/01/26 18:15:39 jklowden Exp $
 # Build FreeTDS and assorted utilities for Win32/Win64 without an IDE. 
 # Makefiles, unlike Visual Studio project files, are stable over time.  
 # Contributed to the public domain by James K. Lowden, February 2009
@@ -83,6 +83,7 @@ TDS_SRC =	$(TDS_DIR)\bulk.c \
 		$(TDS_DIR)\numeric.c \
 		$(TDS_DIR)\query.c \
 		$(TDS_DIR)\read.c \
+		$(TDS_DIR)\sspi.c \
 		$(TDS_DIR)\tds_checks.c \
 		$(TDS_DIR)\tdsstring.c \
 		$(TDS_DIR)\threadsafe.c \
@@ -111,6 +112,7 @@ TDS_OBJ =	$(TDS_OUT)\bulk.obj \
 		$(TDS_OUT)\numeric.obj \
 		$(TDS_OUT)\query.obj \
 		$(TDS_OUT)\read.obj \
+		$(TDS_OUT)\sspi.obj \
 		$(TDS_OUT)\tds_checks.obj \
 		$(TDS_OUT)\tdsstring.obj \
 		$(TDS_OUT)\threadsafe.obj \
diff --git a/src/tds/sspi.c b/src/tds/sspi.c
index 86c3735..10616fc 100644
--- a/src/tds/sspi.c
+++ b/src/tds/sspi.c
@@ -30,6 +30,7 @@
 #endif /* HAVE_STRING_H */
 
 #if HAVE_SSPI
+#define SECURITY_WIN32
 
 #include <windows.h>
 #include <security.h>
@@ -44,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sspi.c,v 1.1 2010/01/26 11:21:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sspi.c,v 1.2 2010/01/26 18:15:39 jklowden Exp $");
 
 /**
  * \ingroup libtds
@@ -131,7 +132,7 @@ tds_sspi_handle_next(TDSSOCKET * tds, struct tds_authentication * tds_auth, size
 	auth_buf = (TDS_UCHAR *) malloc(len);
 	if (!auth_buf)
 		return TDS_FAIL;
-	tds_get_n(tds, auth_buf, len);
+	tds_get_n(tds, auth_buf, (int)len);
 
 	in_desc.ulVersion  = out_desc.ulVersion  = SECBUFFER_VERSION;
 	in_desc.cBuffers   = out_desc.cBuffers   = 1;
@@ -140,15 +141,13 @@ tds_sspi_handle_next(TDSSOCKET * tds, struct tds_authentication * tds_auth, size
 
 	in_buf.BufferType = SECBUFFER_TOKEN;
 	in_buf.pvBuffer   = auth_buf;
-	in_buf.cbBuffer   = len;
+	in_buf.cbBuffer   = (ULONG)len;
 
 	out_buf.BufferType = SECBUFFER_TOKEN;
 	out_buf.pvBuffer   = auth->tds_auth.packet;
 	out_buf.cbBuffer   = NTLMBUF_LEN;
 
-	status = sec_fn->InitializeSecurityContextA(&auth->cred, &auth->cred_ctx,
-		// (char *) host,
-		NULL,
+	status = sec_fn->InitializeSecurityContextA(&auth->cred, &auth->cred_ctx, NULL,  
 		ISC_REQ_CONFIDENTIALITY | ISC_REQ_REPLAY_DETECT | ISC_REQ_CONNECTION,
 		0, SECURITY_NETWORK_DREP, &in_desc,
 		0, &auth->cred_ctx, &out_desc,
@@ -212,9 +211,7 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	buf.BufferType = SECBUFFER_TOKEN;
 	buf.pvBuffer   = auth->tds_auth.packet;
 
-	status = sec_fn->InitializeSecurityContextA(&auth->cred, NULL,
-		//(char *) host,
-		"",
+	status = sec_fn->InitializeSecurityContext(&auth->cred, NULL, "",
 		ISC_REQ_CONFIDENTIALITY | ISC_REQ_REPLAY_DETECT | ISC_REQ_CONNECTION,
 		0, SECURITY_NETWORK_DREP,
 		NULL, 0,
@@ -234,7 +231,7 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	return &auth->tds_auth;
 }
 
-#endif
+#endif /* HAVE_SSPI */
 
 /** @} */
 
diff --git a/win32/config.h b/win32/config.h
index 46dfe26..0a0005c 100644
--- a/win32/config.h
+++ b/win32/config.h
@@ -205,6 +205,9 @@
 /* The size of a `__int64', as computed by sizeof. */
 #define SIZEOF___INT64 8
 
+/* Define to 1 if you want to use SSPI for Win32 */
+#define HAVE_SSPI 1
+
 /* Define to 1 if you have the ANSI C header files. */
 #define STDC_HEADERS 1
 

